Option Explicit

'   MsgBox
'  [OK]
Global Const IDOK = 1
'  [Cancel]
Global Const IDCANCEL = 2
'  [Abort]
Global Const IDABORT = 3
'  [Retry]
Global Const IDRETRY = 4
'  [Ignore]
Global Const IDIGNORE = 5
'  [Yes]
Global Const IDYES = 6
'  [No]
Global Const IDNO = 7

Sub DelKey (sD, sKey, sDel As String, iM As Integer)
  ' DelKey -    
  '       
  '
  ' sD   -  
  ' sKey -  
  ' sDel -  
  ' iM   -  (True -  , False - )
  Dim iLen As Integer
  Dim iPos As Integer
  Dim iPosB As Integer
  Dim sTmpA As String
  Dim sTmpB As String
  Dim sTmpD As String
  '
  iLen = Len(sDel)
  iPos = 1
  Do
    iPos = InStr(iPos, sD, sKey)
    If iPos > 0 Then
      If True = iM Then
        ' True -  
        sTmpD = Mid$(sD, iPos - iLen, iLen)
        If sDel = sTmpD Then
          ' 
          sTmpA = Mid$(sD, 1, iPos - iLen - 1)
          sTmpB = Mid$(sD, iPos, Len(sD) - iPos + 1)
          sD = sTmpA + sTmpB
          iPos = iPos - iLen + Len(sKey)
        Else
          iPos = iPos + Len(sKey)
        End If
      Else
        ' False - 
        sTmpD = Mid$(sD, iPos + Len(sKey), iLen)
        If sDel = sTmpD Then
          ' 
          iPosB = iPos + Len(sKey)
          sTmpA = Mid$(sD, 1, iPosB - 1)
          sTmpB = Mid$(sD, iPosB + iLen, Len(sD) - iPosB - iLen + 1)
          sD = sTmpA + sTmpB
          iPos = iPos + Len(sKey)
        Else
          iPos = iPos + Len(sKey)
        End If
      End If
    Else
      Exit Do
    End If
  Loop While True
End Sub

Function iChrInStr (ByVal sC, ByVal sG As String) As Integer
  ' iChrInStr -    
  '     
  '
  '        
  '     .
  '
  ' sC -   
  ' sG - 
  '
  Dim iPos As Integer
  '
  If 0 = Len(sC) Then
    '     
    '   
    iChrInStr = False
    Exit Function
  End If
  iPos = InStr(sG, sC)
  If 0 <> iPos Then
    iChrInStr = True
  Else
    iChrInStr = False
  End If
End Function

Function iInStrRight (iP As Integer, sA, sB As String) As Integer
  ' InStrRight -     ,
  '  InStr,      
  '     .
  '
  ' iP -    
  ' sA -     
  ' sB -  
  Dim iI As Integer
  Dim iTmpP As Integer
  Dim iTmpPos As Integer
  Dim iStrLen As Integer
  '
  iStrLen = Len(sA)
  '
  If Len(sB) = 0 Then
    iInStrRight = 0
    Exit Function
  ElseIf iStrLen = 0 Then
    iInStrRight = 0
    Exit Function
  ElseIf iP <= 0 Then
    iInStrRight = 0
    Exit Function
  ElseIf iP > iStrLen Then
    iInStrRight = 0
    Exit Function
  End If
  '
  iTmpP = iStrLen - iP + 1
  '
  For iI = iTmpP To 1 Step -1
    iTmpPos = InStr(iI, sA, sB)
    If iTmpPos <> 0 Then
      iInStrRight = iStrLen - iTmpPos
      Exit Function
    End If
  Next iI
End Function

Sub InsKey (sD, sKey, sIns As String, iM As Integer)
  ' InsKeyNum -   
  '     .
  '
  ' sD   -  
  ' sKey -  
  ' sIns -  
  ' iM   -  (True -  , False - )
  Dim iLen As Integer
  Dim iPos As Integer
  Dim iPosB As Integer
  Dim sTmpA As String
  Dim sTmpB As String
  Dim sTmpI As String
  '
  iLen = Len(sIns)
  iPos = 1
  Do
    iPos = InStr(iPos, sD, sKey)
    If iPos > 0 Then
      If True = iM Then
        ' True -  
        sTmpA = Mid$(sD, 1, iPos - 1)
        sTmpB = Mid$(sD, iPos, Len(sD) - iPos + 1)
        sD = sTmpA + sIns + sTmpB
        iPos = iPos + iLen + Len(sKey)
      Else
        ' False - 
        iPosB = iPos + Len(sKey)
        sTmpA = Mid$(sD, 1, iPosB - 1)
        sTmpB = Mid$(sD, iPosB, Len(sD) - iPosB + 1)
        sD = sTmpA + sIns + sTmpB
        iPos = iPos + Len(sKey) + iLen
      End If
    Else
      Exit Do
    End If
  Loop While True
End Sub

Sub InsKeyNum (sD, sKey, sIns As String, iM As Integer)
  ' InsKeyNum -   
  '     ,     
  '    (0123456789)
  '
  ' sD   -  
  ' sKey -  
  ' sIns -  
  ' iM   -  (True -  , False - )
  Dim iLen As Integer
  Dim iPos As Integer
  Dim iPosB As Integer
  Dim sTmpA As String
  Dim sTmpB As String
  Dim sTmpI As String
  '
  iLen = Len(sIns)
  iPos = 1
  Do
    iPos = InStr(iPos, sD, sKey)
    If iPos > 0 Then
      If True = iM Then
        ' True -  
        If 1 < iPos Then
          sTmpI = Mid$(sD, iPos - 1, 1)
        Else
          sTmpI = ""
        End If
        If Not iChrInStr(sTmpI, "0123456789") Then
          ' 
          sTmpA = Mid$(sD, 1, iPos - 1)
          sTmpB = Mid$(sD, iPos, Len(sD) - iPos + 1)
          sD = sTmpA + sIns + sTmpB
          iPos = iPos + iLen + Len(sKey)
        Else
          iPos = iPos + Len(sKey)
        End If
      Else
        ' False - 
        If (Len(sD) - Len(sKey)) > iPos Then
          sTmpI = Mid$(sD, iPos + Len(sKey), 1)
        Else
          sTmpI = ""
        End If
        If Not iChrInStr(sTmpI, "0123456789") Then
          ' 
          iPosB = iPos + Len(sKey)
          sTmpA = Mid$(sD, 1, iPosB - 1)
          sTmpB = Mid$(sD, iPosB, Len(sD) - iPosB + 1)
          sD = sTmpA + sIns + sTmpB
          iPos = iPos + Len(sKey) + iLen
        Else
          iPos = iPos + Len(sKey)
        End If
      End If
    Else
      Exit Do
    End If
  Loop While True
End Sub

Function iReplace (sD, sOld, sNew As String) As Integer
  ' iReplace -    
  '    
  '
  ' :
  ' True  -      
  ' False -      
  '
  ' sD   -  
  ' sOld -   
  ' sNew -    
  Dim iLen As Integer
  Dim iPos As Integer
  Dim iPosB As Integer
  Dim sTmpA As String
  Dim sTmpB As String
  '
  ' ,       ->
  iReplace = False
  iLen = Len(sOld)
  iPos = 1
  Do
    iPos = InStr(iPos, sD, sOld)
    If iPos > 0 Then
      '      
      sTmpA = Mid$(sD, 1, iPos - 1)
      '      
      iPosB = iPos + iLen
      sTmpB = Mid$(sD, iPosB, Len(sD) - iPosB + 1)
      '    
      sD = sTmpA + sNew + sTmpB
      iPos = iPos + Len(sNew)
      ' ->    
      iReplace = True
    Else
      Exit Do
    End If
  Loop While True
End Function

Function sLeftCut (sA, sB As String) As String
  ' sLeftCut -     
  '     .
  '
  ' sA -  
  ' sB -  
  If Len(sA) = 0 Then
    sLeftCut = ""
    Exit Function
  ElseIf Len(sB) = 0 Then
    sLeftCut = ""
    Exit Function
  ElseIf InStr(sA, sB) = 0 Then
    sLeftCut = ""
    Exit Function
  End If
  '
  sLeftCut = Left$(sA, InStr(sA, sB) - 1)
  sA = Right$(sA, Len(sA) - InStr(sA, sB) - Len(sB) + 1)
End Function

Function sRightCut (sA, sB As String) As String
  ' sRightCut -     
  '     .
  '
  ' sA -  
  ' sB -  
  If Len(sA) = 0 Then
    sRightCut = ""
    Exit Function
  ElseIf Len(sB) = 0 Then
    sRightCut = ""
    Exit Function
  ElseIf InStr(sA, sB) = 0 Then
    sRightCut = ""
    Exit Function
  End If
  '
  sRightCut = Right$(sA, iInStrRight(1, sA, sB) - Len(sB) + 1)
  sA = Left$(sA, Len(sA) - iInStrRight(1, sA, sB) - 1)
End Function

